<template>
  <div class="app-container">
    <el-row>
      <!--用户数据1-->
        <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
          <el-form-item label="考试名称" prop="userName">
            <el-input
              v-model="queryParams.userName"
              placeholder="请输入考试名称"
              clearable
              style="width: 150px"
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>
          <el-form-item label="考试时间">
            <el-date-picker
              v-model="dateRange"
              style="width: 240px"
              value-format="yyyy-MM-dd"
              type="daterange"
              range-separator="-"
              start-placeholder="开始日期"
              end-placeholder="结束日期"
            ></el-date-picker>
          </el-form-item>
          <el-form-item label="模拟器类型" prop="userName">
            <el-input
              v-model="queryParams.userName"
              placeholder="请输入模拟器类型"
              clearable
              style="width: 240px"
              @keyup.enter.native="handleQuery"
            />
          </el-form-item>
          <el-form-item label="考试状态" prop="status">
            <el-select
              v-model="queryParams.status"
              placeholder="考试状态"
              clearable
              style="width: 150px"
            >
              <el-option
                v-for="dict in dict.type.sys_normal_disable"
                :key="dict.value"
                :label="dict.label"
                :value="dict.value"
              />
            </el-select>
          </el-form-item>
        
          <el-form-item>
            <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>
        <!-- <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button
              type="primary"
              plain
              icon="el-icon-plus"
              size="mini"
              @click="handleAdd"
              v-hasPermi="['simulator:task:add']"
            >新增</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button
              type="success"
              plain
              icon="el-icon-edit"
              size="mini"
              :disabled="single"
              @click="handleUpdate"
              v-hasPermi="['simulator:user:edit']"
            >修改</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button
              type="danger"
              plain
              icon="el-icon-delete"
              size="mini"
              :disabled="multiple"
              @click="handleDelete"
              v-hasPermi="['simulator:user:remove']"
            >删除</el-button>
          </el-col>
          <right-toolbar :showSearch.sync="showSearch" @queryTable="getList" :columns="columns"></right-toolbar>
        </el-row> -->

        <el-table v-loading="loading" :data="userList" @selection-change="handleSelectionChange">
          <el-table-column type="selection" width="50" align="center" />
          <el-table-column label="考试名称" align="center" key="userName" prop="userName" v-if="columns[0].visible" :show-overflow-tooltip="true" />
          <el-table-column label="考试时间" align="center" key="kaoshiTime" prop="kaoshiTime" v-if="columns[1].visible" :show-overflow-tooltip="true" />
          <el-table-column label="模拟器类型" align="center" key="liexing" prop="liexing" v-if="columns[2].visible" :show-overflow-tooltip="true" />
          <el-table-column label="创建老师" align="center" key="creater" prop="creater" v-if="columns[3].visible" :show-overflow-tooltip="true" />
          <el-table-column label="考试状态" align="center" key="status" v-if="columns[4].visible">
            <template slot-scope="scope">
              <el-switch
                v-model="scope.row.status"
                active-value="0"
                inactive-value="1"
                @change="handleStatusChange(scope.row)"
              ></el-switch>
            </template>
          </el-table-column>
          <el-table-column
            label="操作"
            align="center"
            width="160"
            class-name="small-padding fixed-width"
          >
            <template slot-scope="scope">
              <el-button
                size="mini"
                type="text"
                icon="el-icon-thumb"
                @click="handleInto(scope.row)" 
              >进入</el-button>
            </template>
          </el-table-column>
        </el-table>

        <pagination
          v-show="total>0"
          :total="total"
          :page.sync="queryParams.pageNum"
          :limit.sync="queryParams.pageSize"
          @pagination="getList"
        />
    </el-row>

    <!-- 添加或修改用户配置对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="70%" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-row>
          <el-col :span="12">
            <el-form-item label="型号">
              <!-- v-model="form.monitype" -->
              <el-select v-model="selectedEquip"  placeholder="请选择模拟器型号">
                <el-option
                  value="请选择"
                >请选择</el-option>
                <el-option
                  v-for="dict in dict.type.sim_equip_type"
                  :key="dict.value"
                  :label="dict.label"
                  :value="dict.value"
                ></el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="任务名称" prop="userName">
              <el-input  placeholder="请输入任务名称" maxlength="30" />
            </el-form-item>
          </el-col>
          <div style="text-align: right;">
            <el-button @click="toggleSelection(tableData)">选择全部</el-button>
            <el-button @click="toggleSelection()">取消选择</el-button>
          </div>
        </el-row>
        
          
       
        <el-table 
          :data="tableData" border ref="multipleTable" @selection-change="handleSelectionRow" 
          :span-method="objectSpanMethod" 
          style="width:100%;text-align:center;margin-left:10px; margin-top:10px">
          <el-table-column
            prop="xinghao"
            label="型号">
          </el-table-column>
          <el-table-column
            prop="xianxiang"
            label="故障现象">
          </el-table-column>
          <el-table-column
            prop="name"
            label="故障部位">
          </el-table-column>
          <el-table-column
          type="selection" prop="ids"
            label="ID"
          width="55"></el-table-column>
        </el-table>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    
    
  </div>
</template>
<style>
  .el-table__header tr th .cell{
    text-align: center;
  }
  .el-table__row .cell {
    text-align: center;
  }
  /* .el-form-item__label{
    width: 85px !important;
  } */
</style>
<script>
import { listUser, getUser, delUser, addUser, updateUser, resetUserPwd, changeUserStatus, deptTreeSelect } from "@/api/system/user";
import { getToken } from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";

export default {
  // name: "Task",
  dicts: ['sim_equip_type'],
  components: { Treeselect },
  data() {
    return {
      multipleSelection: [],
      selectedEquip: '',
      selectedZjEquip: '',
      
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 用户表格数据
      userList: null,
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: undefined,
      // 是否显示弹出层
      open: false,
      //自检弹出框
      zijianopen:false,
      // 部门名称
      deptName: undefined,
      // 默认密码
      initPassword: undefined,
      // 日期范围
      dateRange: [],
      // 岗位选项
      postOptions: [],
      // 角色选项
      roleOptions: [],
      // 表单参数
      form: {},
      defaultProps: {
        children: "children",
        label: "label"
      },
      // 用户导入参数
      upload: {
        // 是否显示弹出层（用户导入）
        open: false,
        // 弹出层标题（用户导入）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的用户数据
        updateSupport: 0,
        // 设置上传的请求头部
        headers: { Authorization: "Bearer " + getToken() },
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/simulator/user/importData"
      },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        userName: undefined,
        phonenumber: undefined,
        status: undefined,
        deptId: undefined
      },
      // 列信息
      columns: [
        { key: 0, label: `考试名称`, visible: true },
        { key: 1, label: `考试时间`, visible: true },
        { key: 2, label: `模拟器类型`, visible: true },
        { key: 3, label: `考试状态`, visible: true },
        { key: 4, label: `创建老师`, visible: true },
      ],
      // 表单校验
      rules: {
      }
    };
  },
  watch: {
    // 根据名称筛选部门树
    deptName(val) {
      this.$refs.tree.filter(val);
    },
    
    
  },
  created() {
    this.getList();
    //this.getDeptTree();
    this.getConfigKey("sys.user.initPassword").then(response => {
      this.initPassword = response.msg;
    });
  },
  methods: {
    objectSpanMethod({ row, column, rowIndex, columnIndex }) {
      // console.log(this.selectedEquip+'@@@')
      //第一列型号
      if(columnIndex === 0) {
        if(this.selectedEquip==2){
          if(rowIndex==0){
            return { rowspan: 13, colspan: 1 };
          }
          return { rowspan: 0, colspan: 0 };
        }else if(this.selectedEquip==3){
          if(rowIndex==0){
            return { rowspan: 16, colspan: 1 };
          }
          return { rowspan: 0, colspan: 0};
        }else{
          if(rowIndex==0){
            return { rowspan: 11, colspan: 1 };
          }else if(rowIndex==11){
            return { rowspan: 13, colspan: 1 };
          }else if(rowIndex==24){
            return { rowspan: 16, colspan: 1 };
          }else{
            return { rowspan: 0, colspan: 0 };
          }
        }
      }

      //第二列故障现象
      if(columnIndex === 1) {
        if(this.selectedEquip==2){
          // console.log(rowIndex+'####')
          if(rowIndex<9 && rowIndex % 2 === 0){
            return { rowspan: 2, colspan: 1 };
          }else if((rowIndex>9&&rowIndex<13)){
            return { rowspan: 1, colspan: 1 };
          }else{
            return { rowspan: 0, colspan: 0 };
          } 
        }else if(this.selectedEquip==3){
          if(rowIndex<7 && rowIndex % 2 === 0){
            return { rowspan: 2, colspan: 1 };
          }else if((rowIndex==8)){
            return { rowspan: 3, colspan: 1 };
          }else if(rowIndex==11){
            return { rowspan: 2, colspan: 1 };
          }else if(rowIndex>12 && rowIndex<16){
            return { rowspan: 1, colspan: 1 };
          }else{
            return { rowspan: 0, colspan: 0 };
          } 
        }else{
          if(rowIndex<7 && rowIndex % 2 === 0){
            return { rowspan: 2, colspan: 1 };
          }else if((rowIndex>7&&rowIndex<11) || (rowIndex>20&&rowIndex<24) || (rowIndex>36)){
            return { rowspan: 1, colspan: 1 };
          }else if((rowIndex==35) || (rowIndex>10 && rowIndex<20) && rowIndex % 2 === 1){
            return { rowspan: 2, colspan: 1 };
          }else if(rowIndex>23 && rowIndex<32 && rowIndex % 2 === 0){
            return { rowspan: 2, colspan: 1 };
          }else if(rowIndex==32){
            return { rowspan: 3, colspan: 1 };
          }else{
            return { rowspan: 0, colspan: 0 };
          }
        }
        
      }
      //故障部位 和 选择
      if(columnIndex === 2 || columnIndex === 3){
        //return { rowspan: 1, colspan: 1 };
      }
    },
    
    objectSpanMethod1({ row, column, rowIndex, columnIndex }) {
      //第二列故障现象
      if(columnIndex === 0) {
        if(rowIndex<7 && rowIndex % 2 === 0){
          return { rowspan: 2, colspan: 1 };
        }else if((rowIndex>7&&rowIndex<11) || (rowIndex>20&&rowIndex<24) || (rowIndex>36)){
          return { rowspan: 1, colspan: 1 };
        }else if((rowIndex==35) || (rowIndex>10 && rowIndex<20) && rowIndex % 2 === 1){
          return { rowspan: 2, colspan: 1 };
        }else if(rowIndex>23 && rowIndex<32 && rowIndex % 2 === 0){
          return { rowspan: 2, colspan: 1 };
        }else if(rowIndex==32){
          return { rowspan: 3, colspan: 1 };
        }else{
          return { rowspan: 0, colspan: 0 };
        }
      }
    },
    // 根据选择的option获取新的数据
    // getNewTableData(option) {
    //   // 逻辑处理返回新的数据数组
    //   return [
    //     // ...新数据
    //   ];
    // },
    toggleSelection(rows) {
      if (rows) {
        rows.forEach(row => {
          this.$refs.multipleTable.toggleRowSelection(row);
          console.log(row.ids+'###')
          console.log(row.name+'@@@')
        });
      } else {
        this.$refs.multipleTable.clearSelection();
      }
    },
    handleSelectionRow(val) {
      this.multipleSelection = val;
    },
    /** 查询用户列表 */
    getList() {
      this.loading = true;
      listUser(this.addDateRange(this.queryParams, this.dateRange)).then(response => {
          //将返回值注释
          this.userList = response.rows;
          this.total = response.total;
          this.loading = false;
        }
      );
    },
    /** 查询部门下拉树结构 */
    getDeptTree() {
      deptTreeSelect().then(response => {
        this.deptOptions = response.data;
      });
    },
    // 筛选节点
    filterNode(value, data) {
      if (!value) return true;
      return data.label.indexOf(value) !== -1;
    },
    // 节点单击事件
    handleNodeClick(data) {
      this.queryParams.deptId = data.id;
      this.handleQuery();
    },
    // 用户状态修改
    handleStatusChange(row) {
      let text = row.status === "0" ? "启用" : "停用";
      this.$modal.confirm('确认要"' + text + '""' + row.userName + '"用户吗？').then(function() {
        return changeUserStatus(row.userId, row.status);
      }).then(() => {
        this.$modal.msgSuccess(text + "成功");
      }).catch(function() {
        row.status = row.status === "0" ? "1" : "0";
      });
    },
    //清除故障
    clearFaultChange(row,number,nametext){
      console.log()
      // console.log(nametext+'###')
      // console.log(row[nametext]+'@@@')
      // console.log(row.name1+'@@@')
      let text1 = '清除所有模拟器故障';
      console.log(nametext + '###name1');
      if(nametext != 'all'){
        text1 = '清除'+ number +'号坐席模拟器故障';
      }
      this.$modal.confirm('确认要"' + text1 + '"吗？').then(function() {
        // return changeUserStatus(row.userId, row.status);
      }).then(() => {
        this.$modal.msgSuccess(text1 + "成功");
      }).catch(function() {
        // row.status = row.status === "0" ? "1" : "0";
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.zijianopen = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        userId: undefined,
        deptId: undefined,
        userName: undefined,
        
        password: undefined,
        phonenumber: undefined,
        email: undefined,
        sex: undefined,
        status: "0",
        remark: undefined,
        postIds: [],
        roleIds: []
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = [];
      this.resetForm("queryForm");
      this.queryParams.deptId = undefined;
      this.$refs.tree.setCurrentKey(null);
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.userId);
      this.single = selection.length != 1;
      this.multiple = !selection.length;
    },
    // 更多操作触发
    handleCommand(command, row) {
      switch (command) {
        case "handleResetPwd":
          this.handleResetPwd(row);
          break;
        case "handleAuthRole":
          this.handleAuthRole(row);
          break;
        default:
          break;
      }
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      getUser().then(response => {
        this.postOptions = response.posts;
        this.roleOptions = response.roles;
        this.open = true;
        this.title = "新增训练任务";
        this.form.password = this.initPassword;
      });
    },
    /* 故障设置自检 **/
    handleInspect() {
      //this.reset();
      getUser().then(response => {
        //this.postOptions = response.posts;
        //this.roleOptions = response.roles;
        this.zijianopen = true;
        this.title = "故障设置自检";
      });
    },

    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const userId = row.userId || this.ids;
      getUser(userId).then(response => {
        this.form = response.data;
        this.postOptions = response.posts;
        this.roleOptions = response.roles;
        this.$set(this.form, "postIds", response.postIds);
        this.$set(this.form, "roleIds", response.roleIds);
        this.open = true;
        this.title = "修改用户";
        this.form.password = "";
      });
    },
    /** 重置密码按钮操作 */
    handleResetPwd(row) {
      this.$prompt('请输入"' + row.userName + '"的新密码', "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        closeOnClickModal: false,
        inputPattern: /^.{5,20}$/,
        inputErrorMessage: "用户密码长度必须介于 5 和 20 之间",
        inputValidator: (value) => {
          if (/<|>|"|'|\||\\/.test(value)) {
            return "不能包含非法字符：< > \" ' \\\ |"
          }
        },
      }).then(({ value }) => {
          resetUserPwd(row.userId, value).then(response => {
            this.$modal.msgSuccess("修改成功，新密码是：" + value);
          });
        }).catch(() => {});
    },

    /** 进入操作 */
    handleInto: function(row) {
      const userId = row.userId;
      console.log(userId)
      this.$router.push("/people/exam-exam1/examid/" + userId);
    },
    /** 提交按钮 */
    submitForm: function() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.userId != undefined) {
            updateUser(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addUser(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const userIds = row.userId || this.ids;
      this.$modal.confirm('是否确认删除用户编号为"' + userIds + '"的数据项？').then(function() {
        return delUser(userIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    //训练任务下发
    handleIssued(row) {
      const userIds = row.userId || this.ids;
      this.$modal.confirm('是否确定编号为"' + userIds + '"的训练任务？').then(function() {
        //return delUser(userIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },

    /** 导出按钮操作 */
    handleExport() {
      this.download('simulator/user/export', {
        ...this.queryParams
      }, `user_${new Date().getTime()}.xlsx`)
    },
    /** 导入按钮操作 */
    handleImport() {
      this.upload.title = "用户导入";
      this.upload.open = true;
    },
    /** 下载模板操作 */
    importTemplate() {
      this.download('simulator/user/importTemplate', {
      }, `user_template_${new Date().getTime()}.xlsx`)
    },
    // 文件上传中处理
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true;
    },
    // 文件上传成功处理
    handleFileSuccess(response, file, fileList) {
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      this.$alert("<div style='overflow: auto;overflow-x: hidden;max-height: 70vh;padding: 10px 20px 0;'>" + response.msg + "</div>", "导入结果", { dangerouslyUseHTMLString: true });
      this.getList();
    },
    // 提交上传文件
    submitFileForm() {
      this.$refs.upload.submit();
    }
  }
};
</script>
